// Flow Sensor

int Pulses = 3; //Arduino digital pin 3 is declared as Pulses
int led = 13; //Led pin
volatile int pulsecount; //Variable to count number of pulses
volatile int i = 0;  //Variable for led status

void setup()
{
  pinMode(Pulses, INPUT_PULLUP); //Interrupt pin 3 declared as input and pull up resitor is enabled
  pinMode(led, OUTPUT); //Led as output
  //Interrupt is attached to pin 3
  //ISR(interuupt service routine) of interrupt is CountPulses
  //Interrupt is activated on HIGH to LOW transition
  attachInterrupt(digitalPinToInterrupt(Pulses), CountPulses, FALLING);
  Serial.begin(9600);  //Starting serial monitor
}
void loop()
{
  pulsecount = 0;  //Start counting from 0 again
  i = 0;           //Reset led toggling variable
  interrupts();    //Enables interrupt on arduino pin 3
  delay (1000);    //Wait 1 second
  noInterrupts();  //Disable the interrupt

  //One second is over now and we have the number of pulses in variable
  //'pulsecount'

  //Calculating the water flow rate in Milli Liters per minute
  double flowRate;
  flowRate = (pulsecount * 2.22 * 60);

  Serial.print("Flow rate=");
  Serial.print(flowRate);   //Print milli liters per minute on serial monitor
  Serial.println("mL/minute");
}

void CountPulses()
{
  pulsecount++; //Increment the variable on every pulse
  //On every pulse toggle the state of led.
  if (i % 2 == 0)
    digitalWrite(led, HIGH);
  else
    digitalWrite(led, LOW);
  i++;
}
