#include <Servo.h>

//Soil Moisture Sensor
int sensorPin = A0;
int moistureValue; 
int limit = 500; //Test value. This is the value to change to set the min moisture level of the plants

//Servo
Servo servo; //Pin 4 digital

// Flow Sensor
int Pulses = 3; //Arduino digital pin 3 is declared as Pulses
int led = 13; //Led pin
int value = 500; //Test value. This is the value to change to set the max amount of water the plants need
volatile int pulsecount; //Variable to count number of pulses
volatile int i = 0;  //Variable for led status

void setup()
{
  //Soil Moisture Sensor N/A

  //Servo
  servo.attach(4);
  servo.write(160);
  delay(1000);

  // Flow Sensor
  pinMode(Pulses, INPUT_PULLUP); //Interrupt pin 3 declared as input and pull up resitor is enabled
  pinMode(led, OUTPUT); //Led as output
  //Interrupt is attached to pin 3
  //ISR(interuupt service routine) of interrupt is CountPulses
  //Interrupt is activated on HIGH to LOW transition
  attachInterrupt(digitalPinToInterrupt(Pulses), CountPulses, FALLING);

  //Serial monitor
  Serial.begin(9600);
}

void loop()
{
  // Flow Sensor Shit
  pulsecount = 0;  //Start counting from 0 again
  i = 0;           //Reset led toggling variable
  interrupts();    //Enables interrupt on arduino pin 3
  delay (1000);    //Wait 1 second
  noInterrupts();  //Disable the interrupt

  //One second is over now and we have the number of pulses in variable
  //'pulsecount'

  //Calculating the water flow rate in Milli Liters per minute
  double flowRate;
  flowRate = (pulsecount * 2.22 * 60);

  //THE CODE
  if (moistureValue >= limit) //If value of soil lower then limit
  {
    servo.write(65);  //Switch Servo ON
    delay(1000);

    if (flowRate >= value) //The amount of water we need to feed the plants
    {
      servo.write(160);
      delay(1000);
    }
    else
    {
      servo.write(65);
      delay(1000);
    }
  }
  else // If value of soil higher then limit
  {
    servo.write(160); //Switch Solenoid OFF
    delay(1000);
  }

  //Serial Monitor
  //Soil Moisture Sensor
  moistureValue = analogRead(sensorPin);
  Serial.println("Analog Value : ");
  Serial.println(moistureValue);
  // Flow Sensor
  Serial.print("Flow rate =");
  Serial.print(flowRate); //Print milli liters per minute on serial monitor
  Serial.println("mL/minute");
}

//For the Flow Sensor
void CountPulses()
{
  pulsecount++; //Increment the variable on every pulse
  //On every pulse toggle the state of led.
  if (i % 2 == 0)
    digitalWrite(led, HIGH);
  else
    digitalWrite(led, LOW);
  i++;
}
